HDU 2955 Robberies

来源:互联网 发布:dmsp夜间灯光数据 编辑:程序博客网 时间:2024/06/08 02:53

传送门点我
**

Robberies

**


**

Problem Description

**

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

**

Input

**

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 

Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .


**

Output

**
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.


**

Notes and Constraints

**
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.


**

Sample Input

**
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05


**

Sample Output

**
2
4
6

**

Source

**
IDI Open 2009

**


**

题意


有个人去抢银行,有n个银行 对于第i个银行里有Mi million dollars…

然后会有一个浮点数Pi表示抢第i个银行会降低Pi的生还率…

然后这个人的善良的麻麻预估了一个捉捕率(1-生还率)上限 如果高于此上线就会被捉到QAQ

问最多能抢多少钱QAQ
**

Solution

**
由于noip写挂了dp…所以dp重头学起QAQ

一个01背包题
dp[j]表示抢 j million dollars 的时候被捉捕的最小概率是多少

然后我们就可以放心的跑01背包惹~~

需要注意的是….我的数组又开小了QAQ…RE了一次…以后不能再犯这样的错误了QAQ


**

Code

**

#include <cstdio>#include <iostream>#include <algorithm>#include <cstring>using namespace std;const int maxn=11000;double dp[maxn];int main(){    //freopen("in.txt","r",stdin);    int T;    scanf("%d",&T);    while(T--)    {        memset(dp,0,sizeof(dp));        dp[0]=1;        double pos;        int n,sum=0;        cin>>pos>>n;        pos=1-pos;        for(int i=1;i<=n;i++)        {            double p;int w;            cin>>w>>p;            sum+=w;            for(int j=sum;j>=w;j--)                dp[j]=max(dp[j],dp[j-w]*(1-p));        }        for(int i=sum;i>=0;i--)        if(dp[i]>pos)            {                printf("%d\n",i);                break;            }       }    return 0;}


——既然选择了远方,便只顾风雨兼程

0 0